;; This is Oleg Kiselyov's "Standard Prelude"  
;; $Id: myenv.scm,v 1.9 2001/01/25 00:32:06 oleg Exp oleg $
;; ported to PLT Schemes
;;
;; Suggestions and bug reports: lisovsky@acm.org


;==============================================================================
; Monadic IO

; like cout << arguments << args
; where argument can be any Scheme object. If it's a procedure
; (without args) it's executed rather than printed (like newline)

(define (cout . args)
  (for-each (lambda (x)
              (if (procedure? x) (x) (display x)))
            args))


(define (cerr . args)
  (for-each (lambda (x)
	      (if (procedure? x) (x (current-error-port)) 
		(display x (current-error-port))))
	    args))

(define nl (string #\newline))

